"use strict";
/********************************************************************************
 * Copyright (C) 2019 Red Hat, Inc. and others.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License v. 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0.
 *
 * This Source Code may also be made available under the following Secondary
 * Licenses when the conditions for such availability set forth in the Eclipse
 * Public License v. 2.0 are satisfied: GNU General Public License, version 2
 * with the GNU Classpath Exception which is available at
 * https://www.gnu.org/software/classpath/license.html.
 *
 * SPDX-License-Identifier: EPL-2.0 OR GPL-2.0 WITH Classpath-exception-2.0
 ********************************************************************************/
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SelectionProviderCommandContribution = exports.SelectionProviderCommands = void 0;
var inversify_1 = require("inversify");
var uri_command_handler_1 = require("@theia/core/lib/common/uri-command-handler");
var core_1 = require("@theia/core");
var uri_components_1 = require("../../common/uri-components");
var SelectionProviderCommands;
(function (SelectionProviderCommands) {
    SelectionProviderCommands.GET_SELECTED_CONTEXT = {
        id: 'theia.plugin.workspace.selectedContext'
    };
})(SelectionProviderCommands = exports.SelectionProviderCommands || (exports.SelectionProviderCommands = {}));
var SelectionProviderCommandContribution = /** @class */ (function () {
    function SelectionProviderCommandContribution() {
    }
    SelectionProviderCommandContribution.prototype.registerCommands = function (commands) {
        commands.registerCommand(SelectionProviderCommands.GET_SELECTED_CONTEXT, this.newMultiUriAwareCommandHandler({
            isEnabled: function () { return true; },
            isVisible: function () { return false; },
            execute: function (selectedUris) { return selectedUris.map(function (uri) { return uri_components_1.theiaUritoUriComponents(uri); }); }
        }));
    };
    SelectionProviderCommandContribution.prototype.newMultiUriAwareCommandHandler = function (handler) {
        return uri_command_handler_1.UriAwareCommandHandler.MultiSelect(this.selectionService, handler);
    };
    __decorate([
        inversify_1.inject(core_1.SelectionService),
        __metadata("design:type", core_1.SelectionService)
    ], SelectionProviderCommandContribution.prototype, "selectionService", void 0);
    SelectionProviderCommandContribution = __decorate([
        inversify_1.injectable()
    ], SelectionProviderCommandContribution);
    return SelectionProviderCommandContribution;
}());
exports.SelectionProviderCommandContribution = SelectionProviderCommandContribution;
//# sourceMappingURL=selection-provider-command.js.map