"use strict";
/********************************************************************************
 * Copyright (C) 2018 Red Hat, Inc. and others.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License v. 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0.
 *
 * This Source Code may also be made available under the following Secondary
 * Licenses when the conditions for such availability set forth in the Eclipse
 * Public License v. 2.0 are satisfied: GNU General Public License, version 2
 * with the GNU Classpath Exception which is available at
 * https://www.gnu.org/software/classpath/license.html.
 *
 * SPDX-License-Identifier: EPL-2.0 OR GPL-2.0 WITH Classpath-exception-2.0
 ********************************************************************************/
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PluginApiContribution = void 0;
var path = require("path");
var connect = require("connect");
var serveStatic = require("serve-static");
var vhost = require('vhost');
var inversify_1 = require("inversify");
var webview_protocol_1 = require("../common/webview-protocol");
var environment_1 = require("@theia/application-package/lib/environment");
var pluginPath = (process.env.HOME || process.env.HOMEPATH || process.env.USERPROFILE) + './theia/plugins/';
var PluginApiContribution = /** @class */ (function () {
    function PluginApiContribution() {
    }
    PluginApiContribution.prototype.configure = function (app) {
        app.get('/plugin/:path(*)', function (req, res) {
            var filePath = req.params.path;
            res.sendFile(pluginPath + filePath);
        });
        var webviewApp = connect();
        webviewApp.use('/webview', serveStatic(path.join(__dirname, '../../../src/main/browser/webview/pre')));
        var webviewExternalEndpoint = this.webviewExternalEndpoint();
        console.log("Configuring to accept webviews on '" + webviewExternalEndpoint + "' hostname.");
        app.use(vhost(new RegExp(webviewExternalEndpoint, 'i'), webviewApp));
    };
    PluginApiContribution.prototype.webviewExternalEndpoint = function () {
        var endpointPattern;
        if (environment_1.environment.electron.is()) {
            endpointPattern = webview_protocol_1.WebviewExternalEndpoint.defaultPattern;
        }
        else {
            endpointPattern = process.env[webview_protocol_1.WebviewExternalEndpoint.pattern] || webview_protocol_1.WebviewExternalEndpoint.defaultPattern;
        }
        return endpointPattern
            .replace('{{uuid}}', '.+')
            .replace('{{hostname}}', '.+');
    };
    PluginApiContribution = __decorate([
        inversify_1.injectable()
    ], PluginApiContribution);
    return PluginApiContribution;
}());
exports.PluginApiContribution = PluginApiContribution;
//# sourceMappingURL=plugin-service.js.map