"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var inversify_1 = require("inversify");
var logger_1 = require("@theia/core/lib/common/logger");
var command_1 = require("@theia/core/lib/common/command");
var quick_open_1 = require("@theia/core/lib/browser/quick-open");
var keybinding_1 = require("@theia/core/lib/browser/keybinding");
var boards_quick_open_service_1 = require("./boards-quick-open-service");
exports.default = new inversify_1.ContainerModule(function (bind) {
    bind(boards_quick_open_service_1.BoardsQuickOpenService).toSelf().inSingletonScope();
    bind(command_1.CommandContribution).toService(boards_quick_open_service_1.BoardsQuickOpenService);
    bind(keybinding_1.KeybindingContribution).toService(boards_quick_open_service_1.BoardsQuickOpenService);
    bind(quick_open_1.QuickOpenContribution).toService(boards_quick_open_service_1.BoardsQuickOpenService);
    bind(logger_1.ILogger).toDynamicValue(function (_a) {
        var container = _a.container;
        return container.get(logger_1.ILogger).child('boards-quick-open');
    })
        .inSingletonScope()
        .whenTargetNamed('boards-quick-open');
});
//# sourceMappingURL=boards-quick-open-module.js.map