"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.About = void 0;
var inversify_1 = require("inversify");
var moment = require("moment");
var electron_1 = require("electron");
var os_1 = require("@theia/core/lib/common/os");
var clipboard_service_1 = require("@theia/core/lib/browser/clipboard-service");
var frontend_application_config_provider_1 = require("@theia/core/lib/browser/frontend-application-config-provider");
var contribution_1 = require("./contribution");
var arduino_menus_1 = require("../menu/arduino-menus");
var protocol_1 = require("../../common/protocol");
var About = /** @class */ (function (_super) {
    __extends(About, _super);
    function About() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    About_1 = About;
    About.prototype.registerCommands = function (registry) {
        var _this = this;
        registry.registerCommand(About_1.Commands.ABOUT_APP, {
            execute: function () { return _this.showAbout(); }
        });
    };
    About.prototype.registerMenus = function (registry) {
        registry.registerMenuAction(arduino_menus_1.ArduinoMenus.HELP__ABOUT_GROUP, {
            commandId: About_1.Commands.ABOUT_APP.id,
            label: "About " + this.applicationName,
            order: '0'
        });
    };
    About.prototype.showAbout = function () {
        return __awaiter(this, void 0, void 0, function () {
            var ideStatus, _a, version, commit, cliStatus, buildDate, detail, ok, copy, buttons, response;
            var _this = this;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        ideStatus = frontend_application_config_provider_1.FrontendApplicationConfigProvider.get()['status'];
                        return [4 /*yield*/, this.configService.getVersion()];
                    case 1:
                        _a = _b.sent(), version = _a.version, commit = _a.commit, cliStatus = _a.status;
                        buildDate = this.buildDate;
                        detail = function (useAgo) { return "Version: " + electron_1.remote.app.getVersion() + "\nDate: " + (buildDate ? buildDate : 'dev build') + (buildDate && useAgo ? " (" + _this.ago(buildDate) + ")" : '') + "\nCLI Version: " + version + (cliStatus ? " " + cliStatus : '') + " [" + commit + "]\n\nCopyright \u00A9 " + new Date().getFullYear() + " Arduino SA\n"; };
                        ok = 'OK';
                        copy = 'Copy';
                        buttons = !os_1.isWindows && !os_1.isOSX ? [copy, ok] : [ok, copy];
                        return [4 /*yield*/, electron_1.remote.dialog.showMessageBox(electron_1.remote.getCurrentWindow(), {
                                message: "" + this.applicationName + (ideStatus ? " \u2013 " + ideStatus : ''),
                                title: "" + this.applicationName + (ideStatus ? " \u2013 " + ideStatus : ''),
                                type: 'info',
                                detail: detail(true),
                                buttons: buttons,
                                noLink: true,
                                defaultId: buttons.indexOf(ok),
                                cancelId: buttons.indexOf(ok)
                            })];
                    case 2:
                        response = (_b.sent()).response;
                        if (!(buttons[response] === copy)) return [3 /*break*/, 4];
                        return [4 /*yield*/, this.clipboardService.writeText(detail(false))];
                    case 3:
                        _b.sent();
                        _b.label = 4;
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    Object.defineProperty(About.prototype, "applicationName", {
        get: function () {
            return frontend_application_config_provider_1.FrontendApplicationConfigProvider.get().applicationName;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(About.prototype, "buildDate", {
        get: function () {
            return frontend_application_config_provider_1.FrontendApplicationConfigProvider.get().buildDate;
        },
        enumerable: false,
        configurable: true
    });
    About.prototype.ago = function (isoTime) {
        var now = moment(Date.now());
        var other = moment(isoTime);
        var result = now.diff(other, 'minute');
        if (result < 60) {
            return result === 1 ? result + " minute ago" : result + " minute ago";
        }
        result = now.diff(other, 'hour');
        if (result < 25) {
            return result === 1 ? result + " hour ago" : result + " hours ago";
        }
        result = now.diff(other, 'day');
        if (result < 8) {
            return result === 1 ? result + " day ago" : result + " days ago";
        }
        result = now.diff(other, 'week');
        if (result < 5) {
            return result === 1 ? result + " week ago" : result + " weeks ago";
        }
        result = now.diff(other, 'month');
        if (result < 13) {
            return result === 1 ? result + " month ago" : result + " months ago";
        }
        result = now.diff(other, 'year');
        return result === 1 ? result + " year ago" : result + " years ago";
    };
    var About_1;
    __decorate([
        inversify_1.inject(clipboard_service_1.ClipboardService),
        __metadata("design:type", Object)
    ], About.prototype, "clipboardService", void 0);
    __decorate([
        inversify_1.inject(protocol_1.ConfigService),
        __metadata("design:type", Object)
    ], About.prototype, "configService", void 0);
    About = About_1 = __decorate([
        inversify_1.injectable()
    ], About);
    return About;
}(contribution_1.Contribution));
exports.About = About;
(function (About) {
    var Commands;
    (function (Commands) {
        Commands.ABOUT_APP = {
            id: 'arduino-about'
        };
    })(Commands = About.Commands || (About.Commands = {}));
})(About = exports.About || (exports.About = {}));
exports.About = About;
//# sourceMappingURL=about.js.map