"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Debug = void 0;
var inversify_1 = require("inversify");
var event_1 = require("@theia/core/lib/common/event");
var hosted_plugin_1 = require("@theia/plugin-ext/lib/hosted/browser/hosted-plugin");
var arduino_toolbar_1 = require("../toolbar/arduino-toolbar");
var notification_center_1 = require("../notification-center");
var protocol_1 = require("../../common/protocol");
var boards_service_provider_1 = require("../boards/boards-service-provider");
var contribution_1 = require("./contribution");
var Debug = /** @class */ (function (_super) {
    __extends(Debug, _super);
    function Debug() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**
         * If `undefined`, debugging is enabled. Otherwise, the reason why it's disabled.
         */
        _this._disabledMessages = 'No board selected'; // Initial pessimism.
        _this.disabledMessageDidChangeEmitter = new event_1.Emitter();
        _this.onDisabledMessageDidChange = _this.disabledMessageDidChangeEmitter.event;
        _this.debugToolbarItem = {
            id: Debug_1.Commands.START_DEBUGGING.id,
            command: Debug_1.Commands.START_DEBUGGING.id,
            tooltip: "" + (_this.disabledMessage ? "Debug - " + _this.disabledMessage : 'Start Debugging'),
            priority: 3,
            onDidChange: _this.onDisabledMessageDidChange
        };
        return _this;
    }
    Debug_1 = Debug;
    Object.defineProperty(Debug.prototype, "disabledMessage", {
        get: function () {
            return this._disabledMessages;
        },
        set: function (message) {
            this._disabledMessages = message;
            this.disabledMessageDidChangeEmitter.fire(this._disabledMessages);
        },
        enumerable: false,
        configurable: true
    });
    Debug.prototype.onStart = function () {
        var _this = this;
        this.onDisabledMessageDidChange(function () { return _this.debugToolbarItem.tooltip = "" + (_this.disabledMessage ? "Debug - " + _this.disabledMessage : 'Start Debugging'); });
        var refreshState = function (board) {
            if (board === void 0) { board = _this.boardsServiceProvider.boardsConfig.selectedBoard; }
            return __awaiter(_this, void 0, void 0, function () {
                var fqbn, details, debuggingSupported;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!board) {
                                this.disabledMessage = 'No board selected';
                                return [2 /*return*/];
                            }
                            fqbn = board.fqbn;
                            if (!fqbn) {
                                this.disabledMessage = "Platform is not installed for '" + board.name + "'";
                                return [2 /*return*/];
                            }
                            return [4 /*yield*/, this.boardService.getBoardDetails({ fqbn: fqbn })];
                        case 1:
                            details = _a.sent();
                            if (!details) {
                                this.disabledMessage = "Platform is not installed for '" + board.name + "'";
                                return [2 /*return*/];
                            }
                            debuggingSupported = details.debuggingSupported;
                            if (!debuggingSupported) {
                                this.disabledMessage = "Debugging is not supported by '" + board.name + "'";
                            }
                            else {
                                this.disabledMessage = undefined;
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        this.boardsServiceProvider.onBoardsConfigChanged(function (_a) {
            var selectedBoard = _a.selectedBoard;
            return refreshState(selectedBoard);
        });
        this.notificationCenter.onPlatformInstalled(function () { return refreshState(); });
        this.notificationCenter.onPlatformUninstalled(function () { return refreshState(); });
        refreshState();
    };
    Debug.prototype.registerCommands = function (registry) {
        var _this = this;
        registry.registerCommand(Debug_1.Commands.START_DEBUGGING, {
            execute: function () { return _this.startDebug(); },
            isVisible: function (widget) { return arduino_toolbar_1.ArduinoToolbar.is(widget) && widget.side === 'left'; },
            isEnabled: function () { return !_this.disabledMessage; }
        });
    };
    Debug.prototype.registerToolbarItems = function (registry) {
        registry.registerItem(this.debugToolbarItem);
    };
    Debug.prototype.startDebug = function (board) {
        if (board === void 0) { board = this.boardsServiceProvider.boardsConfig.selectedBoard; }
        return __awaiter(this, void 0, void 0, function () {
            var name, fqbn, _a, sketch, executables, _b, cliPath, sketchPath, config;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        if (!board) {
                            return [2 /*return*/];
                        }
                        name = board.name, fqbn = board.fqbn;
                        if (!fqbn) {
                            return [2 /*return*/];
                        }
                        return [4 /*yield*/, this.hostedPluginSupport.didStart];
                    case 1:
                        _c.sent();
                        return [4 /*yield*/, Promise.all([
                                this.sketchServiceClient.currentSketch(),
                                this.executableService.list()
                            ])];
                    case 2:
                        _a = __read.apply(void 0, [_c.sent(), 2]), sketch = _a[0], executables = _a[1];
                        if (!sketch) {
                            return [2 /*return*/];
                        }
                        return [4 /*yield*/, Promise.all([
                                this.fileService.fsPath(new contribution_1.URI(executables.cliUri)),
                                this.fileService.fsPath(new contribution_1.URI(sketch.uri))
                            ])];
                    case 3:
                        _b = __read.apply(void 0, [_c.sent(), 2]), cliPath = _b[0], sketchPath = _b[1];
                        config = {
                            cliPath: cliPath,
                            board: {
                                fqbn: fqbn,
                                name: name
                            },
                            sketchPath: sketchPath
                        };
                        return [2 /*return*/, this.commandService.executeCommand('arduino.debug.start', config)];
                }
            });
        });
    };
    var Debug_1;
    __decorate([
        inversify_1.inject(hosted_plugin_1.HostedPluginSupport),
        __metadata("design:type", hosted_plugin_1.HostedPluginSupport)
    ], Debug.prototype, "hostedPluginSupport", void 0);
    __decorate([
        inversify_1.inject(notification_center_1.NotificationCenter),
        __metadata("design:type", notification_center_1.NotificationCenter)
    ], Debug.prototype, "notificationCenter", void 0);
    __decorate([
        inversify_1.inject(protocol_1.ExecutableService),
        __metadata("design:type", Object)
    ], Debug.prototype, "executableService", void 0);
    __decorate([
        inversify_1.inject(protocol_1.BoardsService),
        __metadata("design:type", Object)
    ], Debug.prototype, "boardService", void 0);
    __decorate([
        inversify_1.inject(boards_service_provider_1.BoardsServiceProvider),
        __metadata("design:type", boards_service_provider_1.BoardsServiceProvider)
    ], Debug.prototype, "boardsServiceProvider", void 0);
    Debug = Debug_1 = __decorate([
        inversify_1.injectable()
    ], Debug);
    return Debug;
}(contribution_1.SketchContribution));
exports.Debug = Debug;
(function (Debug) {
    var Commands;
    (function (Commands) {
        Commands.START_DEBUGGING = {
            id: 'arduino-start-debug',
            label: 'Start Debugging',
            category: 'Arduino'
        };
    })(Commands = Debug.Commands || (Debug.Commands = {}));
})(Debug = exports.Debug || (exports.Debug = {}));
exports.Debug = Debug;
//# sourceMappingURL=debug.js.map