"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Settings = void 0;
var inversify_1 = require("inversify");
var contribution_1 = require("./contribution");
var arduino_menus_1 = require("../menu/arduino-menus");
var settings_1 = require("../settings");
var Settings = /** @class */ (function (_super) {
    __extends(Settings, _super);
    function Settings() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.settingsOpened = false;
        return _this;
    }
    Settings_1 = Settings;
    Settings.prototype.registerCommands = function (registry) {
        var _this = this;
        registry.registerCommand(Settings_1.Commands.OPEN, {
            execute: function () { return __awaiter(_this, void 0, void 0, function () {
                var settings;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            settings = undefined;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, , 3, 4]);
                            this.settingsOpened = true;
                            return [4 /*yield*/, this.settingsDialog.open()];
                        case 2:
                            settings = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            this.settingsOpened = false;
                            return [7 /*endfinally*/];
                        case 4:
                            if (!settings) return [3 /*break*/, 7];
                            return [4 /*yield*/, this.settingsService.update(settings)];
                        case 5:
                            _a.sent();
                            return [4 /*yield*/, this.settingsService.save()];
                        case 6:
                            _a.sent();
                            return [3 /*break*/, 9];
                        case 7: return [4 /*yield*/, this.settingsService.reset()];
                        case 8:
                            _a.sent();
                            _a.label = 9;
                        case 9: return [2 /*return*/];
                    }
                });
            }); },
            isEnabled: function () { return !_this.settingsOpened; }
        });
    };
    Settings.prototype.registerMenus = function (registry) {
        registry.registerMenuAction(arduino_menus_1.ArduinoMenus.FILE__SETTINGS_GROUP, {
            commandId: Settings_1.Commands.OPEN.id,
            label: 'Preferences...',
            order: '0'
        });
    };
    Settings.prototype.registerKeybindings = function (registry) {
        registry.registerKeybinding({
            command: Settings_1.Commands.OPEN.id,
            keybinding: 'CtrlCmd+,',
        });
    };
    var Settings_1;
    __decorate([
        inversify_1.inject(settings_1.SettingsDialog),
        __metadata("design:type", settings_1.SettingsDialog)
    ], Settings.prototype, "settingsDialog", void 0);
    Settings = Settings_1 = __decorate([
        inversify_1.injectable()
    ], Settings);
    return Settings;
}(contribution_1.SketchContribution));
exports.Settings = Settings;
(function (Settings) {
    var Commands;
    (function (Commands) {
        Commands.OPEN = {
            id: 'arduino-settings-open',
            label: 'Open Preferences...',
            category: 'Arduino'
        };
    })(Commands = Settings.Commands || (Settings.Commands = {}));
})(Settings = exports.Settings || (exports.Settings = {}));
exports.Settings = Settings;
//# sourceMappingURL=settings.js.map