"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Sketchbook = void 0;
var inversify_1 = require("inversify");
var disposable_1 = require("@theia/core/lib/common/disposable");
var contribution_1 = require("./contribution");
var arduino_menus_1 = require("../menu/arduino-menus");
var main_menu_manager_1 = require("../../common/main-menu-manager");
var notification_center_1 = require("../notification-center");
var open_sketch_1 = require("./open-sketch");
var Sketchbook = /** @class */ (function (_super) {
    __extends(Sketchbook, _super);
    function Sketchbook() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.toDisposePerSketch = new Map();
        return _this;
    }
    Sketchbook.prototype.onStart = function () {
        var _this = this;
        this.sketchService.getSketches().then(function (sketches) {
            _this.register(sketches);
            _this.mainMenuManager.update();
        });
        this.sketchServiceClient.onSketchbookDidChange(function (_a) {
            var created = _a.created, removed = _a.removed;
            _this.unregister(removed);
            _this.register(created);
            _this.mainMenuManager.update();
        });
    };
    Sketchbook.prototype.registerMenus = function (registry) {
        registry.registerSubmenu(arduino_menus_1.ArduinoMenus.FILE__SKETCHBOOK_SUBMENU, 'Sketchbook', { order: '3' });
    };
    Sketchbook.prototype.register = function (sketches) {
        var e_1, _a;
        var _this = this;
        var _loop_1 = function (sketch) {
            var uri = sketch.uri;
            var toDispose = this_1.toDisposePerSketch.get(uri);
            if (toDispose) {
                toDispose.dispose();
            }
            var command = { id: "arduino-sketchbook-open--" + uri };
            var handler = { execute: function () { return _this.commandRegistry.executeCommand(open_sketch_1.OpenSketch.Commands.OPEN_SKETCH.id, sketch); } };
            this_1.commandRegistry.registerCommand(command, handler);
            this_1.menuRegistry.registerMenuAction(arduino_menus_1.ArduinoMenus.FILE__SKETCHBOOK_SUBMENU, { commandId: command.id, label: sketch.name });
            this_1.toDisposePerSketch.set(sketch.uri, new disposable_1.DisposableCollection(disposable_1.Disposable.create(function () { return _this.commandRegistry.unregisterCommand(command); }), disposable_1.Disposable.create(function () { return _this.menuRegistry.unregisterMenuAction(command); })));
        };
        var this_1 = this;
        try {
            for (var sketches_1 = __values(sketches), sketches_1_1 = sketches_1.next(); !sketches_1_1.done; sketches_1_1 = sketches_1.next()) {
                var sketch = sketches_1_1.value;
                _loop_1(sketch);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (sketches_1_1 && !sketches_1_1.done && (_a = sketches_1.return)) _a.call(sketches_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
    };
    Sketchbook.prototype.unregister = function (sketches) {
        var e_2, _a;
        try {
            for (var sketches_2 = __values(sketches), sketches_2_1 = sketches_2.next(); !sketches_2_1.done; sketches_2_1 = sketches_2.next()) {
                var uri = sketches_2_1.value.uri;
                var toDispose = this.toDisposePerSketch.get(uri);
                if (toDispose) {
                    toDispose.dispose();
                }
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (sketches_2_1 && !sketches_2_1.done && (_a = sketches_2.return)) _a.call(sketches_2);
            }
            finally { if (e_2) throw e_2.error; }
        }
    };
    __decorate([
        inversify_1.inject(contribution_1.CommandRegistry),
        __metadata("design:type", contribution_1.CommandRegistry)
    ], Sketchbook.prototype, "commandRegistry", void 0);
    __decorate([
        inversify_1.inject(contribution_1.MenuModelRegistry),
        __metadata("design:type", contribution_1.MenuModelRegistry)
    ], Sketchbook.prototype, "menuRegistry", void 0);
    __decorate([
        inversify_1.inject(main_menu_manager_1.MainMenuManager),
        __metadata("design:type", Object)
    ], Sketchbook.prototype, "mainMenuManager", void 0);
    __decorate([
        inversify_1.inject(notification_center_1.NotificationCenter),
        __metadata("design:type", notification_center_1.NotificationCenter)
    ], Sketchbook.prototype, "notificationCenter", void 0);
    Sketchbook = __decorate([
        inversify_1.injectable()
    ], Sketchbook);
    return Sketchbook;
}(contribution_1.SketchContribution));
exports.Sketchbook = Sketchbook;
//# sourceMappingURL=sketchbook.js.map