"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UploadSketch = void 0;
var inversify_1 = require("inversify");
var output_channel_1 = require("@theia/output/lib/common/output-channel");
var protocol_1 = require("../../common/protocol");
var arduino_menus_1 = require("../menu/arduino-menus");
var arduino_toolbar_1 = require("../toolbar/arduino-toolbar");
var boards_data_store_1 = require("../boards/boards-data-store");
var monitor_connection_1 = require("../monitor/monitor-connection");
var boards_service_provider_1 = require("../boards/boards-service-provider");
var contribution_1 = require("./contribution");
var UploadSketch = /** @class */ (function (_super) {
    __extends(UploadSketch, _super);
    function UploadSketch() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UploadSketch_1 = UploadSketch;
    UploadSketch.prototype.registerCommands = function (registry) {
        var _this = this;
        registry.registerCommand(UploadSketch_1.Commands.UPLOAD_SKETCH, {
            execute: function () { return _this.uploadSketch(); }
        });
        registry.registerCommand(UploadSketch_1.Commands.UPLOAD_SKETCH_USING_PROGRAMMER, {
            execute: function () { return _this.uploadSketch(true); }
        });
        registry.registerCommand(UploadSketch_1.Commands.UPLOAD_SKETCH_TOOLBAR, {
            isVisible: function (widget) { return arduino_toolbar_1.ArduinoToolbar.is(widget) && widget.side === 'left'; },
            execute: function () { return registry.executeCommand(UploadSketch_1.Commands.UPLOAD_SKETCH.id); }
        });
    };
    UploadSketch.prototype.registerMenus = function (registry) {
        registry.registerMenuAction(arduino_menus_1.ArduinoMenus.SKETCH__MAIN_GROUP, {
            commandId: UploadSketch_1.Commands.UPLOAD_SKETCH.id,
            label: 'Upload',
            order: '1'
        });
        registry.registerMenuAction(arduino_menus_1.ArduinoMenus.SKETCH__MAIN_GROUP, {
            commandId: UploadSketch_1.Commands.UPLOAD_SKETCH_USING_PROGRAMMER.id,
            label: 'Upload Using Programmer',
            order: '2'
        });
    };
    UploadSketch.prototype.registerKeybindings = function (registry) {
        registry.registerKeybinding({
            command: UploadSketch_1.Commands.UPLOAD_SKETCH.id,
            keybinding: 'CtrlCmd+U'
        });
        registry.registerKeybinding({
            command: UploadSketch_1.Commands.UPLOAD_SKETCH_USING_PROGRAMMER.id,
            keybinding: 'CtrlCmd+Shift+U'
        });
    };
    UploadSketch.prototype.registerToolbarItems = function (registry) {
        registry.registerItem({
            id: UploadSketch_1.Commands.UPLOAD_SKETCH_TOOLBAR.id,
            command: UploadSketch_1.Commands.UPLOAD_SKETCH_TOOLBAR.id,
            tooltip: 'Upload',
            priority: 1
        });
    };
    UploadSketch.prototype.uploadSketch = function (usingProgrammer) {
        var _a, _b;
        if (usingProgrammer === void 0) { usingProgrammer = false; }
        return __awaiter(this, void 0, void 0, function () {
            var uri, shouldAutoConnect, monitorConfig, boardsConfig, _c, fqbn, selectedProgrammer, verify, verbose, options, sketchUri, optimizeForDebug, selectedPort, port, programmer, e_1, board, port, waitError_1;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0: return [4 /*yield*/, this.sketchServiceClient.currentSketchFile()];
                    case 1:
                        uri = _d.sent();
                        if (!uri) {
                            return [2 /*return*/];
                        }
                        shouldAutoConnect = false;
                        monitorConfig = this.monitorConnection.monitorConfig;
                        if (!monitorConfig) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.monitorConnection.disconnect()];
                    case 2:
                        _d.sent();
                        if (this.monitorConnection.autoConnect) {
                            shouldAutoConnect = true;
                        }
                        this.monitorConnection.autoConnect = false;
                        _d.label = 3;
                    case 3:
                        _d.trys.push([3, 9, 10, 18]);
                        boardsConfig = this.boardsServiceClientImpl.boardsConfig;
                        return [4 /*yield*/, Promise.all([
                                this.boardsDataStore.appendConfigToFqbn((_a = boardsConfig.selectedBoard) === null || _a === void 0 ? void 0 : _a.fqbn),
                                this.boardsDataStore.getData((_b = boardsConfig.selectedBoard) === null || _b === void 0 ? void 0 : _b.fqbn),
                                this.preferences.get('arduino.upload.verify'),
                                this.preferences.get('arduino.upload.verbose')
                            ])];
                    case 4:
                        _c = __read.apply(void 0, [_d.sent(), 4]), fqbn = _c[0], selectedProgrammer = _c[1].selectedProgrammer, verify = _c[2], verbose = _c[3];
                        options = undefined;
                        sketchUri = uri;
                        optimizeForDebug = this.editorMode.compileForDebug;
                        selectedPort = boardsConfig.selectedPort;
                        port = selectedPort === null || selectedPort === void 0 ? void 0 : selectedPort.address;
                        if (usingProgrammer) {
                            programmer = selectedProgrammer;
                            options = {
                                sketchUri: sketchUri,
                                fqbn: fqbn,
                                optimizeForDebug: optimizeForDebug,
                                programmer: programmer,
                                port: port,
                                verbose: verbose,
                                verify: verify
                            };
                        }
                        else {
                            options = {
                                sketchUri: sketchUri,
                                fqbn: fqbn,
                                optimizeForDebug: optimizeForDebug,
                                port: port,
                                verbose: verbose,
                                verify: verify
                            };
                        }
                        this.outputChannelManager.getChannel('Arduino: upload').clear();
                        if (!usingProgrammer) return [3 /*break*/, 6];
                        return [4 /*yield*/, this.coreService.uploadUsingProgrammer(options)];
                    case 5:
                        _d.sent();
                        return [3 /*break*/, 8];
                    case 6: return [4 /*yield*/, this.coreService.upload(options)];
                    case 7:
                        _d.sent();
                        _d.label = 8;
                    case 8:
                        this.messageService.info('Done uploading.', { timeout: 1000 });
                        return [3 /*break*/, 18];
                    case 9:
                        e_1 = _d.sent();
                        this.messageService.error(e_1.toString());
                        return [3 /*break*/, 18];
                    case 10:
                        if (!monitorConfig) return [3 /*break*/, 17];
                        board = monitorConfig.board, port = monitorConfig.port;
                        _d.label = 11;
                    case 11:
                        _d.trys.push([11, 16, , 17]);
                        return [4 /*yield*/, this.boardsServiceClientImpl.waitUntilAvailable(Object.assign(board, { port: port }), 10000)];
                    case 12:
                        _d.sent();
                        if (!shouldAutoConnect) return [3 /*break*/, 13];
                        // Enabling auto-connect will trigger a connect.
                        this.monitorConnection.autoConnect = true;
                        return [3 /*break*/, 15];
                    case 13: return [4 /*yield*/, this.monitorConnection.connect(monitorConfig)];
                    case 14:
                        _d.sent();
                        _d.label = 15;
                    case 15: return [3 /*break*/, 17];
                    case 16:
                        waitError_1 = _d.sent();
                        this.messageService.error("Could not reconnect to serial monitor. " + waitError_1.toString());
                        return [3 /*break*/, 17];
                    case 17: return [7 /*endfinally*/];
                    case 18: return [2 /*return*/];
                }
            });
        });
    };
    var UploadSketch_1;
    __decorate([
        inversify_1.inject(protocol_1.CoreService),
        __metadata("design:type", Object)
    ], UploadSketch.prototype, "coreService", void 0);
    __decorate([
        inversify_1.inject(monitor_connection_1.MonitorConnection),
        __metadata("design:type", monitor_connection_1.MonitorConnection)
    ], UploadSketch.prototype, "monitorConnection", void 0);
    __decorate([
        inversify_1.inject(boards_data_store_1.BoardsDataStore),
        __metadata("design:type", boards_data_store_1.BoardsDataStore)
    ], UploadSketch.prototype, "boardsDataStore", void 0);
    __decorate([
        inversify_1.inject(boards_service_provider_1.BoardsServiceProvider),
        __metadata("design:type", boards_service_provider_1.BoardsServiceProvider)
    ], UploadSketch.prototype, "boardsServiceClientImpl", void 0);
    __decorate([
        inversify_1.inject(output_channel_1.OutputChannelManager),
        __metadata("design:type", output_channel_1.OutputChannelManager)
    ], UploadSketch.prototype, "outputChannelManager", void 0);
    UploadSketch = UploadSketch_1 = __decorate([
        inversify_1.injectable()
    ], UploadSketch);
    return UploadSketch;
}(contribution_1.SketchContribution));
exports.UploadSketch = UploadSketch;
(function (UploadSketch) {
    var Commands;
    (function (Commands) {
        Commands.UPLOAD_SKETCH = {
            id: 'arduino-upload-sketch'
        };
        Commands.UPLOAD_SKETCH_USING_PROGRAMMER = {
            id: 'arduino-upload-sketch-using-programmer'
        };
        Commands.UPLOAD_SKETCH_TOOLBAR = {
            id: 'arduino-upload-sketch--toolbar'
        };
    })(Commands = UploadSketch.Commands || (UploadSketch.Commands = {}));
})(UploadSketch = exports.UploadSketch || (exports.UploadSketch = {}));
exports.UploadSketch = UploadSketch;
//# sourceMappingURL=upload-sketch.js.map