"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EditorMode = void 0;
var inversify_1 = require("inversify");
var browser_1 = require("@theia/editor/lib/browser");
var output_widget_1 = require("@theia/output/lib/browser/output-widget");
var main_menu_manager_1 = require("../common/main-menu-manager");
var boards_list_widget_1 = require("./boards/boards-list-widget");
var library_list_widget_1 = require("./library/library-list-widget");
var EditorMode = /** @class */ (function () {
    function EditorMode() {
    }
    EditorMode_1 = EditorMode;
    EditorMode.prototype.onStart = function (app) {
        this.app = app;
        if (this.proMode) {
            // We use this CSS class on the body to modify the visibility of the close button for the editors and views.
            document.body.classList.add(EditorMode_1.PRO_MODE_KEY);
        }
    };
    Object.defineProperty(EditorMode.prototype, "proMode", {
        get: function () {
            var value = window.localStorage.getItem(EditorMode_1.PRO_MODE_KEY);
            return value === 'true';
        },
        enumerable: false,
        configurable: true
    });
    EditorMode.prototype.toggleProMode = function () {
        return __awaiter(this, void 0, void 0, function () {
            var oldState, inAdvancedMode, shell, _a, _b, area, layoutRestorer;
            var e_1, _c;
            var _this = this;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        oldState = this.proMode;
                        inAdvancedMode = !oldState;
                        window.localStorage.setItem(EditorMode_1.PRO_MODE_KEY, String(inAdvancedMode));
                        if (!inAdvancedMode) {
                            shell = this.app.shell;
                            try {
                                // Close all widgets that are neither editor nor `Output` / `Boards Manager` / `Library Manager`.
                                for (_a = __values(['left', 'right', 'bottom', 'main']), _b = _a.next(); !_b.done; _b = _a.next()) {
                                    area = _b.value;
                                    shell.closeTabs(area, function (title) { return !_this.isInSimpleMode(title.owner); });
                                }
                            }
                            catch (e_1_1) { e_1 = { error: e_1_1 }; }
                            finally {
                                try {
                                    if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                                }
                                finally { if (e_1) throw e_1.error; }
                            }
                        }
                        layoutRestorer = this.app.layoutRestorer;
                        return [4 /*yield*/, layoutRestorer.storeLayoutAsync(this.app)];
                    case 1:
                        _d.sent();
                        window.location.reload(true);
                        return [2 /*return*/];
                }
            });
        });
    };
    EditorMode.prototype.isInSimpleMode = function (widget) {
        return widget instanceof browser_1.EditorWidget
            || widget instanceof output_widget_1.OutputWidget
            || widget instanceof boards_list_widget_1.BoardsListWidget
            || widget instanceof library_list_widget_1.LibraryListWidget;
    };
    Object.defineProperty(EditorMode.prototype, "compileForDebug", {
        get: function () {
            var value = window.localStorage.getItem(EditorMode_1.COMPILE_FOR_DEBUG_KEY);
            return value === 'true';
        },
        enumerable: false,
        configurable: true
    });
    EditorMode.prototype.toggleCompileForDebug = function () {
        return __awaiter(this, void 0, void 0, function () {
            var oldState, newState;
            return __generator(this, function (_a) {
                oldState = this.compileForDebug;
                newState = !oldState;
                window.localStorage.setItem(EditorMode_1.COMPILE_FOR_DEBUG_KEY, String(newState));
                this.mainMenuManager.update();
                return [2 /*return*/];
            });
        });
    };
    var EditorMode_1;
    __decorate([
        inversify_1.inject(main_menu_manager_1.MainMenuManager),
        __metadata("design:type", Object)
    ], EditorMode.prototype, "mainMenuManager", void 0);
    EditorMode = EditorMode_1 = __decorate([
        inversify_1.injectable()
    ], EditorMode);
    return EditorMode;
}());
exports.EditorMode = EditorMode;
(function (EditorMode) {
    EditorMode.PRO_MODE_KEY = 'arduino-advanced-mode';
    EditorMode.COMPILE_FOR_DEBUG_KEY = 'arduino-compile-for-debug';
})(EditorMode = exports.EditorMode || (exports.EditorMode = {}));
exports.EditorMode = EditorMode;
//# sourceMappingURL=editor-mode.js.map