"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.unregisterSubmenu = exports.ArduinoMenus = void 0;
var os_1 = require("@theia/core/lib/common/os");
var common_frontend_contribution_1 = require("@theia/core/lib/browser/common-frontend-contribution");
var menu_1 = require("@theia/core/lib/common/menu");
var ArduinoMenus;
(function (ArduinoMenus) {
    // Main menu
    // -- File
    ArduinoMenus.FILE__SKETCH_GROUP = __spread(common_frontend_contribution_1.CommonMenus.FILE, ['0_sketch']);
    ArduinoMenus.FILE__PRINT_GROUP = __spread(common_frontend_contribution_1.CommonMenus.FILE, ['1_print']);
    // XXX: on macOS, the settings group is not under `File`
    ArduinoMenus.FILE__SETTINGS_GROUP = __spread((os_1.isOSX ? menu_1.MAIN_MENU_BAR : common_frontend_contribution_1.CommonMenus.FILE), ['2_settings']);
    ArduinoMenus.FILE__QUIT_GROUP = __spread(common_frontend_contribution_1.CommonMenus.FILE, ['3_quit']);
    // -- File / Open Recent
    ArduinoMenus.FILE__OPEN_RECENT_SUBMENU = __spread(ArduinoMenus.FILE__SKETCH_GROUP, ['0_open_recent']);
    // -- File / Sketchbook
    ArduinoMenus.FILE__SKETCHBOOK_SUBMENU = __spread(ArduinoMenus.FILE__SKETCH_GROUP, ['1_sketchbook']);
    // -- File / Examples
    ArduinoMenus.FILE__EXAMPLES_SUBMENU = __spread(ArduinoMenus.FILE__SKETCH_GROUP, ['2_examples']);
    ArduinoMenus.EXAMPLES__BUILT_IN_GROUP = __spread(ArduinoMenus.FILE__EXAMPLES_SUBMENU, ['0_built_ins']);
    ArduinoMenus.EXAMPLES__ANY_BOARD_GROUP = __spread(ArduinoMenus.FILE__EXAMPLES_SUBMENU, ['1_any_board']);
    ArduinoMenus.EXAMPLES__CURRENT_BOARD_GROUP = __spread(ArduinoMenus.FILE__EXAMPLES_SUBMENU, ['2_current_board']);
    ArduinoMenus.EXAMPLES__USER_LIBS_GROUP = __spread(ArduinoMenus.FILE__EXAMPLES_SUBMENU, ['3_user_libs']);
    // -- Edit
    // `Copy`, `Copy to Forum`, `Paste`, etc.
    // Note: `1_undo` is the first group from Theia, we start with `2`
    ArduinoMenus.EDIT__TEXT_CONTROL_GROUP = __spread(common_frontend_contribution_1.CommonMenus.EDIT, ['2_text_control']);
    // `Comment/Uncomment`, etc.
    ArduinoMenus.EDIT__CODE_CONTROL_GROUP = __spread(common_frontend_contribution_1.CommonMenus.EDIT, ['3_code_control']);
    ArduinoMenus.EDIT__FONT_CONTROL_GROUP = __spread(common_frontend_contribution_1.CommonMenus.EDIT, ['4_font_control']);
    ArduinoMenus.EDIT__FIND_GROUP = __spread(common_frontend_contribution_1.CommonMenus.EDIT, ['5_find']);
    // -- Sketch
    ArduinoMenus.SKETCH = __spread(menu_1.MAIN_MENU_BAR, ['3_sketch']);
    ArduinoMenus.SKETCH__MAIN_GROUP = __spread(ArduinoMenus.SKETCH, ['0_main']);
    ArduinoMenus.SKETCH__UTILS_GROUP = __spread(ArduinoMenus.SKETCH, ['1_utils']);
    // -- Tools
    ArduinoMenus.TOOLS = __spread(menu_1.MAIN_MENU_BAR, ['4_tools']);
    // `Auto Format`, `Library Manager...`, `Boards Manager...`
    ArduinoMenus.TOOLS__MAIN_GROUP = __spread(ArduinoMenus.TOOLS, ['0_main']);
    // `Board`, `Port`, and `Get Board Info`.
    ArduinoMenus.TOOLS__BOARD_SELECTION_GROUP = __spread(ArduinoMenus.TOOLS, ['2_board_selection']);
    // Core settings, such as `Processor` and `Programmers` for the board and `Burn Bootloader`
    ArduinoMenus.TOOLS__BOARD_SETTINGS_GROUP = __spread(ArduinoMenus.TOOLS, ['3_board_settings']);
    // -- Help
    // `Getting Started`, `Environment`, `Troubleshooting`, etc.
    ArduinoMenus.HELP__MAIN_GROUP = __spread(common_frontend_contribution_1.CommonMenus.HELP, ['0_main']);
    // `Find in reference`, `FAQ`, etc.
    ArduinoMenus.HELP__FIND_GROUP = __spread(common_frontend_contribution_1.CommonMenus.HELP, ['1_find']);
    // `Advanced Mode`.
    // XXX: this will be removed.
    ArduinoMenus.HELP__CONTROL_GROUP = __spread(common_frontend_contribution_1.CommonMenus.HELP, ['2_control']);
    // `About` group
    // XXX: on macOS, the about group is not under `Help`
    ArduinoMenus.HELP__ABOUT_GROUP = __spread((os_1.isOSX ? menu_1.MAIN_MENU_BAR : common_frontend_contribution_1.CommonMenus.HELP), ['999_about']);
    // ------------
    // Context menus
    // -- Open
    ArduinoMenus.OPEN_SKETCH__CONTEXT = ['arduino-open-sketch--context'];
    ArduinoMenus.OPEN_SKETCH__CONTEXT__OPEN_GROUP = __spread(ArduinoMenus.OPEN_SKETCH__CONTEXT, ['0_open']);
    ArduinoMenus.OPEN_SKETCH__CONTEXT__RECENT_GROUP = __spread(ArduinoMenus.OPEN_SKETCH__CONTEXT, ['1_recent']);
    ArduinoMenus.OPEN_SKETCH__CONTEXT__EXAMPLES_GROUP = __spread(ArduinoMenus.OPEN_SKETCH__CONTEXT, ['2_examples']);
    // -- Sketch control
    ArduinoMenus.SKETCH_CONTROL__CONTEXT = ['arduino-sketch-control--context'];
    // `New Tab`, `Rename`, `Delete`
    ArduinoMenus.SKETCH_CONTROL__CONTEXT__MAIN_GROUP = __spread(ArduinoMenus.SKETCH_CONTROL__CONTEXT, ['0_main']);
    // `Previous Tab`, `Next Tab`
    ArduinoMenus.SKETCH_CONTROL__CONTEXT__NAVIGATION_GROUP = __spread(ArduinoMenus.SKETCH_CONTROL__CONTEXT, ['1_navigation']);
    // Sketch files opened in editors
    ArduinoMenus.SKETCH_CONTROL__CONTEXT__RESOURCES_GROUP = __spread(ArduinoMenus.SKETCH_CONTROL__CONTEXT, ['2_resources']);
})(ArduinoMenus = exports.ArduinoMenus || (exports.ArduinoMenus = {}));
/**
 * This is a hack. It removes a submenu with all its children if any.
 * Theia cannot dispose submenu entries with a proper API: https://github.com/eclipse-theia/theia/issues/7299
 */
function unregisterSubmenu(menuPath, menuRegistry) {
    if (menuPath.length < 2) {
        throw new Error("Expected at least two item as a menu-path. Got " + JSON.stringify(menuPath) + " instead.");
    }
    var toRemove = menuPath[menuPath.length - 1];
    var parentMenuPath = menuPath.slice(0, menuPath.length - 1);
    // This is unsafe. Calling `getMenu` with a non-existing menu-path will result in a new menu creation.
    // https://github.com/eclipse-theia/theia/issues/7300
    var parent = menuRegistry.getMenu(parentMenuPath);
    var index = parent.children.findIndex(function (_a) {
        var id = _a.id;
        return id === toRemove;
    });
    if (index === -1) {
        throw new Error("Could not find menu with menu-path: " + JSON.stringify(menuPath) + ".");
    }
    parent.children.splice(index, 1);
}
exports.unregisterSubmenu = unregisterSubmenu;
//# sourceMappingURL=arduino-menus.js.map