"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SilentMonacoEditorModel = exports.MonacoTextModelService = void 0;
var inversify_1 = require("inversify");
var monaco_editor_model_1 = require("@theia/monaco/lib/browser/monaco-editor-model");
var monaco_text_model_service_1 = require("@theia/monaco/lib/browser/monaco-text-model-service");
var MonacoTextModelService = /** @class */ (function (_super) {
    __extends(MonacoTextModelService, _super);
    function MonacoTextModelService() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    MonacoTextModelService.prototype.createModel = function (resource) {
        var factory = this.factories.getContributions().find(function (_a) {
            var scheme = _a.scheme;
            return resource.uri.scheme === scheme;
        });
        return factory ? factory.createModel(resource) : new SilentMonacoEditorModel(resource, this.m2p, this.p2m, this.logger);
    };
    MonacoTextModelService = __decorate([
        inversify_1.injectable()
    ], MonacoTextModelService);
    return MonacoTextModelService;
}(monaco_text_model_service_1.MonacoTextModelService));
exports.MonacoTextModelService = MonacoTextModelService;
// https://github.com/eclipse-theia/theia/pull/8491
var SilentMonacoEditorModel = /** @class */ (function (_super) {
    __extends(SilentMonacoEditorModel, _super);
    function SilentMonacoEditorModel() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    SilentMonacoEditorModel.prototype.trace = function (loggable) {
        var _this = this;
        if (this.logger) {
            this.logger.trace(function (log) {
                return loggable(function (message) {
                    var params = [];
                    for (var _i = 1; _i < arguments.length; _i++) {
                        params[_i - 1] = arguments[_i];
                    }
                    return log.apply(void 0, __spread([message], params, [_this.resource.uri.toString(true)]));
                });
            });
        }
    };
    return SilentMonacoEditorModel;
}(monaco_editor_model_1.MonacoEditorModel));
exports.SilentMonacoEditorModel = SilentMonacoEditorModel;
//# sourceMappingURL=monaco-text-model-service.js.map