"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WorkspaceInputDialog = void 0;
var inversify_1 = require("inversify");
var label_provider_1 = require("@theia/core/lib/browser/label-provider");
var dialogs_1 = require("@theia/core/lib/browser/dialogs");
var workspace_input_dialog_1 = require("@theia/workspace/lib/browser/workspace-input-dialog");
var WorkspaceInputDialog = /** @class */ (function (_super) {
    __extends(WorkspaceInputDialog, _super);
    function WorkspaceInputDialog(props, labelProvider) {
        var _this = _super.call(this, props, labelProvider) || this;
        _this.props = props;
        _this.labelProvider = labelProvider;
        _this.wasTouched = false;
        _this.appendCloseButton('Cancel');
        return _this;
    }
    WorkspaceInputDialog.prototype.appendParentPath = function () {
        // NOOP
    };
    WorkspaceInputDialog.prototype.isValid = function (value, mode) {
        if (value !== '') {
            this.wasTouched = true;
        }
        return _super.prototype.isValid.call(this, value, mode);
    };
    WorkspaceInputDialog.prototype.setErrorMessage = function (error) {
        if (this.acceptButton) {
            this.acceptButton.disabled = !dialogs_1.DialogError.getResult(error);
        }
        if (this.wasTouched) {
            this.errorMessageNode.innerText = dialogs_1.DialogError.getMessage(error);
        }
    };
    WorkspaceInputDialog = __decorate([
        __param(0, inversify_1.inject(workspace_input_dialog_1.WorkspaceInputDialogProps)),
        __param(1, inversify_1.inject(label_provider_1.LabelProvider)),
        __metadata("design:paramtypes", [workspace_input_dialog_1.WorkspaceInputDialogProps,
            label_provider_1.LabelProvider])
    ], WorkspaceInputDialog);
    return WorkspaceInputDialog;
}(workspace_input_dialog_1.WorkspaceInputDialog));
exports.WorkspaceInputDialog = WorkspaceInputDialog;
//# sourceMappingURL=workspace-input-dialog.js.map