"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Installable = void 0;
var semver = require("semver");
var utils_1 = require("./../utils");
var Installable;
(function (Installable) {
    var Version;
    (function (Version) {
        /**
         * Most recent version comes first, then the previous versions. (`1.8.1`, `1.6.3`, `1.6.2`, `1.6.1` and so on.)
         */
        Version.COMPARATOR = function (left, right) {
            if (semver.valid(left) && semver.valid(right)) {
                return semver.compare(left, right);
            }
            return utils_1.naturalCompare(left, right);
        };
    })(Version = Installable.Version || (Installable.Version = {}));
})(Installable = exports.Installable || (exports.Installable = {}));
//# sourceMappingURL=installable.js.map