"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ElectronWindowService = void 0;
var inversify_1 = require("inversify");
var electron_1 = require("electron");
var frontend_application_state_1 = require("@theia/core/lib/browser/frontend-application-state");
var connection_status_service_1 = require("@theia/core/lib/browser/connection-status-service");
var electron_window_service_1 = require("@theia/core/lib/electron-browser/window/electron-window-service");
var splash_service_1 = require("../electron-common/splash-service");
var ElectronWindowService = /** @class */ (function (_super) {
    __extends(ElectronWindowService, _super);
    function ElectronWindowService() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ElectronWindowService.prototype.init = function () {
        var _this = this;
        this.appStateService.reachedAnyState('initialized_layout').then(function () { return _this.splashService.requestClose(); });
    };
    ElectronWindowService.prototype.shouldUnload = function () {
        var offline = this.connectionStatusService.currentStatus === connection_status_service_1.ConnectionStatus.OFFLINE;
        var detail = offline
            ? 'Could not save the sketch. Please copy your unsaved work into your favorite text editor, and restart the IDE.'
            : 'Any unsaved changes will not be saved.';
        var electronWindow = electron_1.remote.getCurrentWindow();
        var response = electron_1.remote.dialog.showMessageBoxSync(electronWindow, {
            type: 'question',
            buttons: ['Yes', 'No'],
            title: 'Confirm',
            message: 'Are you sure you want to close the sketch?',
            detail: detail
        });
        return response === 0; // 'Yes', close the window.
    };
    __decorate([
        inversify_1.inject(connection_status_service_1.ConnectionStatusService),
        __metadata("design:type", Object)
    ], ElectronWindowService.prototype, "connectionStatusService", void 0);
    __decorate([
        inversify_1.inject(splash_service_1.SplashService),
        __metadata("design:type", Object)
    ], ElectronWindowService.prototype, "splashService", void 0);
    __decorate([
        inversify_1.inject(frontend_application_state_1.FrontendApplicationStateService),
        __metadata("design:type", frontend_application_state_1.FrontendApplicationStateService)
    ], ElectronWindowService.prototype, "appStateService", void 0);
    __decorate([
        inversify_1.postConstruct(),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], ElectronWindowService.prototype, "init", null);
    ElectronWindowService = __decorate([
        inversify_1.injectable()
    ], ElectronWindowService);
    return ElectronWindowService;
}(electron_window_service_1.ElectronWindowService));
exports.ElectronWindowService = ElectronWindowService;
//# sourceMappingURL=electron-window-service.js.map