"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ElectronMainMenuFactory = void 0;
var inversify_1 = require("inversify");
var electron_1 = require("electron");
var electron_main_menu_factory_1 = require("@theia/core/lib/electron-browser/menu/electron-main-menu-factory");
var arduino_menus_1 = require("../../../browser/menu/arduino-menus");
var ElectronMainMenuFactory = /** @class */ (function (_super) {
    __extends(ElectronMainMenuFactory, _super);
    function ElectronMainMenuFactory() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ElectronMainMenuFactory.prototype.createMenuBar = function () {
        this._toggledCommands.clear(); // https://github.com/eclipse-theia/theia/issues/8977
        return _super.prototype.createMenuBar.call(this);
    };
    ElectronMainMenuFactory.prototype.acceleratorFor = function (keybinding) {
        var _this = this;
        // TODO: https://github.com/eclipse-theia/theia/issues/8207
        return this.keybindingRegistry.resolveKeybinding(keybinding)
            .map(function (binding) { return _this.keybindingRegistry.acceleratorForKeyCode(binding, '+'); })
            .join('')
            .replace('←', 'Left')
            .replace('→', 'Right');
    };
    ElectronMainMenuFactory.prototype.createOSXMenu = function () {
        var submenu = _super.prototype.createOSXMenu.call(this).submenu;
        var label = 'Arduino Pro IDE';
        if (!!submenu && !(submenu instanceof electron_1.remote.Menu)) {
            var _a = __read(submenu), rest = _a.slice(2);
            var about = this.fillMenuTemplate([], this.menuProvider.getMenu(arduino_menus_1.ArduinoMenus.HELP__ABOUT_GROUP));
            var settings = this.fillMenuTemplate([], this.menuProvider.getMenu(arduino_menus_1.ArduinoMenus.FILE__SETTINGS_GROUP));
            return {
                label: label,
                submenu: __spread(about, [
                    { type: 'separator' }
                ], settings, [
                    { type: 'separator' }
                ], rest)
            };
        }
        return { label: label, submenu: submenu };
    };
    ElectronMainMenuFactory = __decorate([
        inversify_1.injectable()
    ], ElectronMainMenuFactory);
    return ElectronMainMenuFactory;
}(electron_main_menu_factory_1.ElectronMainMenuFactory));
exports.ElectronMainMenuFactory = ElectronMainMenuFactory;
//# sourceMappingURL=electron-main-menu-factory.js.map