"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var inversify_1 = require("inversify");
var proxy_factory_1 = require("@theia/core/lib/common/messaging/proxy-factory");
var electron_connection_handler_1 = require("@theia/core/lib/electron-common/messaging/electron-connection-handler");
var electron_main_application_1 = require("@theia/core/lib/electron-main/electron-main-application");
var splash_service_1 = require("../electron-common/splash-service");
var splash_service_impl_1 = require("./splash/splash-service-impl");
var electron_main_application_2 = require("./theia/electron-main-application");
exports.default = new inversify_1.ContainerModule(function (bind, unbind, isBound, rebind) {
    bind(electron_main_application_2.ElectronMainApplication).toSelf().inSingletonScope();
    rebind(electron_main_application_1.ElectronMainApplication).toService(electron_main_application_2.ElectronMainApplication);
    bind(splash_service_impl_1.SplashServiceImpl).toSelf().inSingletonScope();
    bind(splash_service_1.SplashService).toService(splash_service_impl_1.SplashServiceImpl);
    bind(electron_connection_handler_1.ElectronConnectionHandler).toDynamicValue(function (context) {
        return new proxy_factory_1.JsonRpcConnectionHandler(splash_service_1.splashServicePath, function () { return context.container.get(splash_service_1.SplashService); });
    }).inSingletonScope();
});
//# sourceMappingURL=arduino-electron-main-module.js.map