"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BoardDiscovery = void 0;
var inversify_1 = require("inversify");
var logger_1 = require("@theia/core/lib/common/logger");
var objects_1 = require("@theia/core/lib/common/objects");
var core_client_provider_1 = require("./core-client-provider");
var board_pb_1 = require("./cli-protocol/commands/board_pb");
var protocol_1 = require("../common/protocol");
/**
 * Singleton service for tracking the available ports and board and broadcasting the
 * changes to all connected frontend instances. \
 * Unlike other services, this is not connection scoped.
 */
var BoardDiscovery = /** @class */ (function () {
    function BoardDiscovery() {
        /**
         * Keys are the `address` of the ports. \
         * The `protocol` is ignored because the board detach event does not carry the protocol information,
         * just the address.
         * ```json
         * {
         *  "type": "remove",
         *  "address": "/dev/cu.usbmodem14101"
         * }
         * ```
         */
        this._state = {};
    }
    Object.defineProperty(BoardDiscovery.prototype, "state", {
        get: function () {
            return this._state;
        },
        enumerable: false,
        configurable: true
    });
    BoardDiscovery.prototype.init = function () {
        return __awaiter(this, void 0, void 0, function () {
            var coreClient, client, instance, req;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.coreClient()];
                    case 1:
                        coreClient = _a.sent();
                        client = coreClient.client, instance = coreClient.instance;
                        req = new board_pb_1.BoardListWatchReq();
                        req.setInstance(instance);
                        this.boardWatchDuplex = client.boardListWatch();
                        this.boardWatchDuplex.on('data', function (resp) {
                            var e_1, _a;
                            var detectedPort = resp.getPort();
                            if (detectedPort) {
                                var eventType = 'unknown';
                                if (resp.getEventType() === 'add') {
                                    eventType = 'add';
                                }
                                else if (resp.getEventType() === 'remove') {
                                    eventType = 'remove';
                                }
                                else {
                                    eventType = 'unknown';
                                }
                                if (eventType === 'unknown') {
                                    throw new Error("Unexpected event type: '" + resp.getEventType() + "'");
                                }
                                var oldState = objects_1.deepClone(_this._state);
                                var newState = objects_1.deepClone(_this._state);
                                var address = detectedPort.getAddress();
                                var protocol = protocol_1.Port.Protocol.toProtocol(detectedPort.getProtocol());
                                // const label = detectedPort.getProtocolLabel();
                                var port = { address: address, protocol: protocol };
                                var boards = [];
                                try {
                                    for (var _b = __values(detectedPort.getBoardsList()), _c = _b.next(); !_c.done; _c = _b.next()) {
                                        var item = _c.value;
                                        boards.push({ fqbn: item.getFqbn(), name: item.getName() || 'unknown', port: port });
                                    }
                                }
                                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                                finally {
                                    try {
                                        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                                    }
                                    finally { if (e_1) throw e_1.error; }
                                }
                                if (eventType === 'add') {
                                    if (newState[port.address] !== undefined) {
                                        var _d = __read(newState[port.address], 2), knownBoards = _d[1];
                                        console.warn("Port '" + port.address + "' was already available. Known boards before override: " + JSON.stringify(knownBoards));
                                    }
                                    newState[port.address] = [port, boards];
                                }
                                else if (eventType === 'remove') {
                                    if (newState[port.address] === undefined) {
                                        console.warn("Port '" + port.address + "' was not available. Skipping");
                                        return;
                                    }
                                    delete newState[port.address];
                                }
                                var oldAvailablePorts = _this.getAvailablePorts(oldState);
                                var oldAttachedBoards = _this.getAttachedBoards(oldState);
                                var newAvailablePorts = _this.getAvailablePorts(newState);
                                var newAttachedBoards = _this.getAttachedBoards(newState);
                                var event_1 = {
                                    oldState: {
                                        ports: oldAvailablePorts,
                                        boards: oldAttachedBoards
                                    },
                                    newState: {
                                        ports: newAvailablePorts,
                                        boards: newAttachedBoards
                                    }
                                };
                                _this._state = newState;
                                _this.notificationService.notifyAttachedBoardsChanged(event_1);
                            }
                        });
                        this.boardWatchDuplex.write(req);
                        return [2 /*return*/];
                }
            });
        });
    };
    BoardDiscovery.prototype.getAttachedBoards = function (state) {
        var e_2, _a;
        if (state === void 0) { state = this.state; }
        var attachedBoards = [];
        try {
            for (var _b = __values(Object.keys(state)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var address = _c.value;
                var _d = __read(state[address], 2), boards = _d[1];
                attachedBoards.push.apply(attachedBoards, __spread(boards));
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_2) throw e_2.error; }
        }
        return attachedBoards;
    };
    BoardDiscovery.prototype.getAvailablePorts = function (state) {
        var e_3, _a;
        if (state === void 0) { state = this.state; }
        var availablePorts = [];
        try {
            for (var _b = __values(Object.keys(state)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var address = _c.value;
                // tslint:disable-next-line: whitespace
                var _d = __read(state[address], 1), port = _d[0];
                availablePorts.push(port);
            }
        }
        catch (e_3_1) { e_3 = { error: e_3_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_3) throw e_3.error; }
        }
        return availablePorts;
    };
    BoardDiscovery.prototype.coreClient = function () {
        return __awaiter(this, void 0, void 0, function () {
            var coreClient;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, new Promise(function (resolve) { return __awaiter(_this, void 0, void 0, function () {
                            var client, toDispose;
                            var _this = this;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4 /*yield*/, this.coreClientProvider.client()];
                                    case 1:
                                        client = _a.sent();
                                        if (client) {
                                            resolve(client);
                                            return [2 /*return*/];
                                        }
                                        toDispose = this.coreClientProvider.onClientReady(function () { return __awaiter(_this, void 0, void 0, function () {
                                            var client;
                                            return __generator(this, function (_a) {
                                                switch (_a.label) {
                                                    case 0: return [4 /*yield*/, this.coreClientProvider.client()];
                                                    case 1:
                                                        client = _a.sent();
                                                        if (client) {
                                                            toDispose.dispose();
                                                            resolve(client);
                                                            return [2 /*return*/];
                                                        }
                                                        return [2 /*return*/];
                                                }
                                            });
                                        }); });
                                        return [2 /*return*/];
                                }
                            });
                        }); })];
                    case 1:
                        coreClient = _a.sent();
                        return [2 /*return*/, coreClient];
                }
            });
        });
    };
    __decorate([
        inversify_1.inject(logger_1.ILogger),
        inversify_1.named('discovery'),
        __metadata("design:type", Object)
    ], BoardDiscovery.prototype, "discoveryLogger", void 0);
    __decorate([
        inversify_1.inject(core_client_provider_1.CoreClientProvider),
        __metadata("design:type", core_client_provider_1.CoreClientProvider)
    ], BoardDiscovery.prototype, "coreClientProvider", void 0);
    __decorate([
        inversify_1.inject(protocol_1.NotificationServiceServer),
        __metadata("design:type", Object)
    ], BoardDiscovery.prototype, "notificationService", void 0);
    __decorate([
        inversify_1.postConstruct(),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", Promise)
    ], BoardDiscovery.prototype, "init", null);
    BoardDiscovery = __decorate([
        inversify_1.injectable()
    ], BoardDiscovery);
    return BoardDiscovery;
}());
exports.BoardDiscovery = BoardDiscovery;
//# sourceMappingURL=board-discovery.js.map