"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CoreClientProvider = void 0;
var grpc = require("@grpc/grpc-js");
var inversify_1 = require("inversify");
var event_1 = require("@theia/core/lib/common/event");
var grpc_client_provider_1 = require("./grpc-client-provider");
var commandsGrpcPb = require("./cli-protocol/commands/commands_grpc_pb");
var commands_pb_1 = require("./cli-protocol/commands/commands_pb");
var protocol_1 = require("../common/protocol");
var CoreClientProvider = /** @class */ (function (_super) {
    __extends(CoreClientProvider, _super);
    function CoreClientProvider() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.onClientReadyEmitter = new event_1.Emitter();
        return _this;
    }
    Object.defineProperty(CoreClientProvider.prototype, "onClientReady", {
        get: function () {
            return this.onClientReadyEmitter.event;
        },
        enumerable: false,
        configurable: true
    });
    CoreClientProvider.prototype.close = function (client) {
        client.client.close();
    };
    CoreClientProvider.prototype.reconcileClient = function (port) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(port && port === this._port)) return [3 /*break*/, 3];
                        if (!this._client) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.updateIndexes(this._client)];
                    case 1:
                        _a.sent();
                        this.onClientReadyEmitter.fire();
                        _a.label = 2;
                    case 2: return [3 /*break*/, 5];
                    case 3: return [4 /*yield*/, _super.prototype.reconcileClient.call(this, port)];
                    case 4:
                        _a.sent();
                        this.onClientReadyEmitter.fire();
                        _a.label = 5;
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    CoreClientProvider.prototype.createClient = function (port) {
        return __awaiter(this, void 0, void 0, function () {
            var ArduinoCoreClient, client, initReq, initResp, instance;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        ArduinoCoreClient = grpc.makeClientConstructor(commandsGrpcPb['cc.arduino.cli.commands.ArduinoCore'], 'ArduinoCoreService');
                        client = new ArduinoCoreClient("localhost:" + port, grpc.credentials.createInsecure(), this.channelOptions);
                        initReq = new commands_pb_1.InitReq();
                        initReq.setLibraryManagerOnly(false);
                        return [4 /*yield*/, new Promise(function (resolve, reject) {
                                var resp = undefined;
                                var stream = client.init(initReq);
                                stream.on('data', function (data) { return resp = data; });
                                stream.on('end', function () { return resolve(resp); });
                                stream.on('error', function (err) { return reject(err); });
                            })];
                    case 1:
                        initResp = _a.sent();
                        instance = initResp.getInstance();
                        if (!instance) {
                            throw new Error("Could not retrieve instance from the initialize response.");
                        }
                        // No `await`. The index update event comes later. This way we do not block app startup with index update when invalid proxy is given.
                        this.updateIndexes({ instance: instance, client: client });
                        return [2 /*return*/, { instance: instance, client: client }];
                }
            });
        });
    };
    CoreClientProvider.prototype.updateIndexes = function (_a) {
        var client = _a.client, instance = _a.instance;
        return __awaiter(this, void 0, void 0, function () {
            var indexUpdateSucceeded, i, e_1, libIndexUpdateSucceeded, i, e_2;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        indexUpdateSucceeded = true;
                        i = 0;
                        _b.label = 1;
                    case 1:
                        if (!(i < 10)) return [3 /*break*/, 6];
                        _b.label = 2;
                    case 2:
                        _b.trys.push([2, 4, , 5]);
                        return [4 /*yield*/, this.updateIndex({ client: client, instance: instance })];
                    case 3:
                        _b.sent();
                        indexUpdateSucceeded = true;
                        return [3 /*break*/, 6];
                    case 4:
                        e_1 = _b.sent();
                        console.error("Error while updating index in attempt " + i + ".", e_1);
                        return [3 /*break*/, 5];
                    case 5:
                        i++;
                        return [3 /*break*/, 1];
                    case 6:
                        if (!indexUpdateSucceeded) {
                            console.error('Could not update the index. Please restart to try again.');
                        }
                        libIndexUpdateSucceeded = true;
                        i = 0;
                        _b.label = 7;
                    case 7:
                        if (!(i < 10)) return [3 /*break*/, 12];
                        _b.label = 8;
                    case 8:
                        _b.trys.push([8, 10, , 11]);
                        return [4 /*yield*/, this.updateLibraryIndex({ client: client, instance: instance })];
                    case 9:
                        _b.sent();
                        libIndexUpdateSucceeded = true;
                        return [3 /*break*/, 12];
                    case 10:
                        e_2 = _b.sent();
                        console.error("Error while updating library index in attempt " + i + ".", e_2);
                        return [3 /*break*/, 11];
                    case 11:
                        i++;
                        return [3 /*break*/, 7];
                    case 12:
                        if (!libIndexUpdateSucceeded) {
                            console.error('Could not update the library index. Please restart to try again.');
                        }
                        if (indexUpdateSucceeded && libIndexUpdateSucceeded) {
                            this.notificationService.notifyIndexUpdated();
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    CoreClientProvider.prototype.updateLibraryIndex = function (_a) {
        var client = _a.client, instance = _a.instance;
        return __awaiter(this, void 0, void 0, function () {
            var req, resp, file;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        req = new commands_pb_1.UpdateLibrariesIndexReq();
                        req.setInstance(instance);
                        resp = client.updateLibrariesIndex(req);
                        resp.on('data', function (data) {
                            var progress = data.getDownloadProgress();
                            if (progress) {
                                if (!file && progress.getFile()) {
                                    file = "" + progress.getFile();
                                }
                                if (progress.getCompleted()) {
                                    if (file) {
                                        if (/\s/.test(file)) {
                                            console.log(file + " completed.");
                                        }
                                        else {
                                            console.log("Download of '" + file + "' completed.");
                                        }
                                    }
                                    else {
                                        console.log('The library index has been successfully updated.');
                                    }
                                    file = undefined;
                                }
                            }
                        });
                        return [4 /*yield*/, new Promise(function (resolve, reject) {
                                resp.on('error', reject);
                                resp.on('end', resolve);
                            })];
                    case 1:
                        _b.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    CoreClientProvider.prototype.updateIndex = function (_a) {
        var client = _a.client, instance = _a.instance;
        return __awaiter(this, void 0, void 0, function () {
            var updateReq, updateResp, file;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        updateReq = new commands_pb_1.UpdateIndexReq();
                        updateReq.setInstance(instance);
                        updateResp = client.updateIndex(updateReq);
                        updateResp.on('data', function (o) {
                            var progress = o.getDownloadProgress();
                            if (progress) {
                                if (!file && progress.getFile()) {
                                    file = "" + progress.getFile();
                                }
                                if (progress.getCompleted()) {
                                    if (file) {
                                        if (/\s/.test(file)) {
                                            console.log(file + " completed.");
                                        }
                                        else {
                                            console.log("Download of '" + file + "' completed.");
                                        }
                                    }
                                    else {
                                        console.log('The index has been successfully updated.');
                                    }
                                    file = undefined;
                                }
                            }
                        });
                        return [4 /*yield*/, new Promise(function (resolve, reject) {
                                updateResp.on('error', reject);
                                updateResp.on('end', resolve);
                            })];
                    case 1:
                        _b.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    __decorate([
        inversify_1.inject(protocol_1.NotificationServiceServer),
        __metadata("design:type", Object)
    ], CoreClientProvider.prototype, "notificationService", void 0);
    CoreClientProvider = __decorate([
        inversify_1.injectable()
    ], CoreClientProvider);
    return CoreClientProvider;
}(grpc_client_provider_1.GrpcClientProvider));
exports.CoreClientProvider = CoreClientProvider;
//# sourceMappingURL=core-client-provider.js.map