"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SketchesServiceImpl = void 0;
var inversify_1 = require("inversify");
var fs = require("fs");
var os = require("os");
var temp = require("temp");
var path = require("path");
var ncp_1 = require("ncp");
var util_1 = require("util");
var uri_1 = require("@theia/core/lib/common/uri");
var node_1 = require("@theia/core/lib/node");
var os_1 = require("@theia/core/lib/common/os");
var config_service_1 = require("../common/protocol/config-service");
var utils_1 = require("../common/utils");
var notification_service_server_1 = require("./notification-service-server");
var env_variables_1 = require("@theia/core/lib/common/env-variables");
var core_client_provider_1 = require("./core-client-provider");
var commands_pb_1 = require("./cli-protocol/commands/commands_pb");
var WIN32_DRIVE_REGEXP = /^[a-zA-Z]:\\/;
var prefix = '.arduinoProIDE-unsaved';
var SketchesServiceImpl = /** @class */ (function () {
    function SketchesServiceImpl() {
    }
    SketchesServiceImpl.prototype.getSketches = function (uri) {
        return __awaiter(this, void 0, void 0, function () {
            var sketchbookPath, sketchDirUri, stat, sketches, filenames, filenames_1, filenames_1_1, fileName, filePath, sketch, stat_1, _a, e_1_1;
            var e_1, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        if (!!uri) return [3 /*break*/, 5];
                        return [4 /*yield*/, this.configService.getConfiguration()];
                    case 1:
                        sketchDirUri = (_c.sent()).sketchDirUri;
                        sketchbookPath = node_1.FileUri.fsPath(sketchDirUri);
                        return [4 /*yield*/, util_1.promisify(fs.exists)(sketchbookPath)];
                    case 2:
                        if (!!(_c.sent())) return [3 /*break*/, 4];
                        return [4 /*yield*/, util_1.promisify(fs.mkdir)(sketchbookPath, { recursive: true })];
                    case 3:
                        _c.sent();
                        _c.label = 4;
                    case 4: return [3 /*break*/, 6];
                    case 5:
                        sketchbookPath = node_1.FileUri.fsPath(uri);
                        _c.label = 6;
                    case 6: return [4 /*yield*/, util_1.promisify(fs.exists)(sketchbookPath)];
                    case 7:
                        if (!(_c.sent())) {
                            return [2 /*return*/, []];
                        }
                        return [4 /*yield*/, util_1.promisify(fs.stat)(sketchbookPath)];
                    case 8:
                        stat = _c.sent();
                        if (!stat.isDirectory()) {
                            return [2 /*return*/, []];
                        }
                        sketches = [];
                        return [4 /*yield*/, util_1.promisify(fs.readdir)(sketchbookPath)];
                    case 9:
                        filenames = _c.sent();
                        _c.label = 10;
                    case 10:
                        _c.trys.push([10, 18, 19, 20]);
                        filenames_1 = __values(filenames), filenames_1_1 = filenames_1.next();
                        _c.label = 11;
                    case 11:
                        if (!!filenames_1_1.done) return [3 /*break*/, 17];
                        fileName = filenames_1_1.value;
                        filePath = path.join(sketchbookPath, fileName);
                        return [4 /*yield*/, this._isSketchFolder(node_1.FileUri.create(filePath).toString())];
                    case 12:
                        sketch = _c.sent();
                        if (!sketch) return [3 /*break*/, 16];
                        _c.label = 13;
                    case 13:
                        _c.trys.push([13, 15, , 16]);
                        return [4 /*yield*/, util_1.promisify(fs.stat)(filePath)];
                    case 14:
                        stat_1 = _c.sent();
                        sketches.push(__assign(__assign({}, sketch), { mtimeMs: stat_1.mtimeMs }));
                        return [3 /*break*/, 16];
                    case 15:
                        _a = _c.sent();
                        console.warn("Could not load sketch from " + filePath + ".");
                        return [3 /*break*/, 16];
                    case 16:
                        filenames_1_1 = filenames_1.next();
                        return [3 /*break*/, 11];
                    case 17: return [3 /*break*/, 20];
                    case 18:
                        e_1_1 = _c.sent();
                        e_1 = { error: e_1_1 };
                        return [3 /*break*/, 20];
                    case 19:
                        try {
                            if (filenames_1_1 && !filenames_1_1.done && (_b = filenames_1.return)) _b.call(filenames_1);
                        }
                        finally { if (e_1) throw e_1.error; }
                        return [7 /*endfinally*/];
                    case 20:
                        sketches.sort(function (left, right) { return right.mtimeMs - left.mtimeMs; });
                        return [2 /*return*/, sketches];
                }
            });
        });
    };
    SketchesServiceImpl.prototype.loadSketch = function (uri) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, client, instance, req, sketch;
            var _this = this;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, this.coreClient()];
                    case 1:
                        _a = _b.sent(), client = _a.client, instance = _a.instance;
                        req = new commands_pb_1.LoadSketchReq();
                        req.setSketchPath(node_1.FileUri.fsPath(uri));
                        req.setInstance(instance);
                        return [4 /*yield*/, new Promise(function (resolve, reject) {
                                client.loadSketch(req, function (err, resp) { return __awaiter(_this, void 0, void 0, function () {
                                    var sketchFolderPath, mtimeMs;
                                    return __generator(this, function (_a) {
                                        switch (_a.label) {
                                            case 0:
                                                if (err) {
                                                    reject(err);
                                                    return [2 /*return*/];
                                                }
                                                sketchFolderPath = resp.getLocationPath();
                                                return [4 /*yield*/, util_1.promisify(fs.lstat)(sketchFolderPath)];
                                            case 1:
                                                mtimeMs = (_a.sent()).mtimeMs;
                                                resolve({
                                                    name: path.basename(sketchFolderPath),
                                                    uri: node_1.FileUri.create(sketchFolderPath).toString(),
                                                    mainFileUri: node_1.FileUri.create(resp.getMainFile()).toString(),
                                                    otherSketchFileUris: resp.getOtherSketchFilesList().map(function (p) { return node_1.FileUri.create(p).toString(); }),
                                                    additionalFileUris: resp.getAdditionalFilesList().map(function (p) { return node_1.FileUri.create(p).toString(); }),
                                                    mtimeMs: mtimeMs
                                                });
                                                return [2 /*return*/];
                                        }
                                    });
                                }); });
                            })];
                    case 2:
                        sketch = _b.sent();
                        return [2 /*return*/, sketch];
                }
            });
        });
    };
    Object.defineProperty(SketchesServiceImpl.prototype, "recentSketchesFsPath", {
        get: function () {
            return this.envVariableServer.getConfigDirUri().then(function (uri) { return path.join(node_1.FileUri.fsPath(uri), 'recent-sketches.json'); });
        },
        enumerable: false,
        configurable: true
    });
    SketchesServiceImpl.prototype.loadRecentSketches = function (fsPath) {
        return __awaiter(this, void 0, void 0, function () {
            var data, raw, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        data = {};
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, util_1.promisify(fs.readFile)(fsPath, { encoding: 'utf8' })];
                    case 2:
                        raw = _b.sent();
                        data = JSON.parse(raw);
                        return [3 /*break*/, 4];
                    case 3:
                        _a = _b.sent();
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/, data];
                }
            });
        });
    };
    SketchesServiceImpl.prototype.markAsRecentlyOpened = function (uri) {
        return __awaiter(this, void 0, void 0, function () {
            var sketch, _a, fsPath, data, now, toDeleteUri, min, _b, _c, uri_2;
            var e_2, _d;
            var _this = this;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        sketch = undefined;
                        _e.label = 1;
                    case 1:
                        _e.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this.loadSketch(uri)];
                    case 2:
                        sketch = _e.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        _a = _e.sent();
                        return [2 /*return*/];
                    case 4: return [4 /*yield*/, this.isTemp(sketch)];
                    case 5:
                        if (_e.sent()) {
                            return [2 /*return*/];
                        }
                        return [4 /*yield*/, this.recentSketchesFsPath];
                    case 6:
                        fsPath = _e.sent();
                        return [4 /*yield*/, this.loadRecentSketches(fsPath)];
                    case 7:
                        data = _e.sent();
                        now = Date.now();
                        data[sketch.uri] = now;
                        toDeleteUri = undefined;
                        if (Object.keys(data).length > 10) {
                            min = Number.MAX_SAFE_INTEGER;
                            try {
                                for (_b = __values(Object.keys(data)), _c = _b.next(); !_c.done; _c = _b.next()) {
                                    uri_2 = _c.value;
                                    if (min > data[uri_2]) {
                                        min = data[uri_2];
                                        toDeleteUri = uri_2;
                                    }
                                }
                            }
                            catch (e_2_1) { e_2 = { error: e_2_1 }; }
                            finally {
                                try {
                                    if (_c && !_c.done && (_d = _b.return)) _d.call(_b);
                                }
                                finally { if (e_2) throw e_2.error; }
                            }
                        }
                        if (toDeleteUri) {
                            delete data[toDeleteUri];
                        }
                        return [4 /*yield*/, util_1.promisify(fs.writeFile)(fsPath, JSON.stringify(data, null, 2))];
                    case 8:
                        _e.sent();
                        this.recentlyOpenedSketches().then(function (sketches) { return _this.notificationService.notifyRecentSketchesChanged({ sketches: sketches }); });
                        return [2 /*return*/];
                }
            });
        });
    };
    SketchesServiceImpl.prototype.recentlyOpenedSketches = function () {
        return __awaiter(this, void 0, void 0, function () {
            var configDirUri, fsPath, data, raw, _a, sketches, _b, _c, uri, sketch, _d, e_3_1;
            var e_3, _e;
            return __generator(this, function (_f) {
                switch (_f.label) {
                    case 0: return [4 /*yield*/, this.envVariableServer.getConfigDirUri()];
                    case 1:
                        configDirUri = _f.sent();
                        fsPath = path.join(node_1.FileUri.fsPath(configDirUri), 'recent-sketches.json');
                        data = {};
                        _f.label = 2;
                    case 2:
                        _f.trys.push([2, 4, , 5]);
                        return [4 /*yield*/, util_1.promisify(fs.readFile)(fsPath, { encoding: 'utf8' })];
                    case 3:
                        raw = _f.sent();
                        data = JSON.parse(raw);
                        return [3 /*break*/, 5];
                    case 4:
                        _a = _f.sent();
                        return [3 /*break*/, 5];
                    case 5:
                        sketches = [];
                        _f.label = 6;
                    case 6:
                        _f.trys.push([6, 13, 14, 15]);
                        _b = __values(Object.keys(data).sort(function (left, right) { return data[right] - data[left]; })), _c = _b.next();
                        _f.label = 7;
                    case 7:
                        if (!!_c.done) return [3 /*break*/, 12];
                        uri = _c.value;
                        _f.label = 8;
                    case 8:
                        _f.trys.push([8, 10, , 11]);
                        return [4 /*yield*/, this.loadSketch(uri)];
                    case 9:
                        sketch = _f.sent();
                        sketches.push(sketch);
                        return [3 /*break*/, 11];
                    case 10:
                        _d = _f.sent();
                        return [3 /*break*/, 11];
                    case 11:
                        _c = _b.next();
                        return [3 /*break*/, 7];
                    case 12: return [3 /*break*/, 15];
                    case 13:
                        e_3_1 = _f.sent();
                        e_3 = { error: e_3_1 };
                        return [3 /*break*/, 15];
                    case 14:
                        try {
                            if (_c && !_c.done && (_e = _b.return)) _e.call(_b);
                        }
                        finally { if (e_3) throw e_3.error; }
                        return [7 /*endfinally*/];
                    case 15: return [2 /*return*/, sketches];
                }
            });
        });
    };
    SketchesServiceImpl.prototype.cloneExample = function (uri) {
        return __awaiter(this, void 0, void 0, function () {
            var sketch, parentPath, destinationUri, copiedSketchUri;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.loadSketch(uri)];
                    case 1:
                        sketch = _a.sent();
                        return [4 /*yield*/, new Promise(function (resolve, reject) {
                                temp.mkdir({ prefix: prefix }, function (err, dirPath) {
                                    if (err) {
                                        reject(err);
                                        return;
                                    }
                                    resolve(dirPath);
                                });
                            })];
                    case 2:
                        parentPath = _a.sent();
                        destinationUri = node_1.FileUri.create(path.join(parentPath, sketch.name)).toString();
                        return [4 /*yield*/, this.copy(sketch, { destinationUri: destinationUri })];
                    case 3:
                        copiedSketchUri = _a.sent();
                        return [2 /*return*/, this.loadSketch(copiedSketchUri)];
                }
            });
        });
    };
    SketchesServiceImpl.prototype.createNewSketch = function () {
        return __awaiter(this, void 0, void 0, function () {
            var monthNames, today, parentPath, sketchBaseName, config, user, sketchName, i, sketchNameCandidate, sketchDir, sketchFile;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        monthNames = ['jan', 'feb', 'mar', 'apr', 'may', 'jun', 'jul', 'aug', 'sep', 'oct', 'nov', 'dec'];
                        today = new Date();
                        return [4 /*yield*/, new Promise(function (resolve, reject) {
                                temp.mkdir({ prefix: prefix }, function (err, dirPath) {
                                    if (err) {
                                        reject(err);
                                        return;
                                    }
                                    resolve(dirPath);
                                });
                            })];
                    case 1:
                        parentPath = _a.sent();
                        sketchBaseName = "sketch_" + monthNames[today.getMonth()] + today.getDate();
                        return [4 /*yield*/, this.configService.getConfiguration()];
                    case 2:
                        config = _a.sent();
                        user = node_1.FileUri.fsPath(config.sketchDirUri);
                        i = 97;
                        _a.label = 3;
                    case 3:
                        if (!(i < 97 + 26)) return [3 /*break*/, 6];
                        sketchNameCandidate = "" + sketchBaseName + String.fromCharCode(i);
                        return [4 /*yield*/, util_1.promisify(fs.exists)(path.join(user, sketchNameCandidate))];
                    case 4:
                        // Note: we check the future destination folder (`directories.user`) for name collision and not the temp folder!
                        if (_a.sent()) {
                            return [3 /*break*/, 5];
                        }
                        sketchName = sketchNameCandidate;
                        return [3 /*break*/, 6];
                    case 5:
                        i++;
                        return [3 /*break*/, 3];
                    case 6:
                        if (!sketchName) {
                            throw new Error('Cannot create a unique sketch name');
                        }
                        sketchDir = path.join(parentPath, sketchName);
                        sketchFile = path.join(sketchDir, sketchName + ".ino");
                        return [4 /*yield*/, util_1.promisify(fs.mkdir)(sketchDir, { recursive: true })];
                    case 7:
                        _a.sent();
                        return [4 /*yield*/, util_1.promisify(fs.writeFile)(sketchFile, "void setup() {\n  // put your setup code here, to run once:\n\n}\n\nvoid loop() {\n  // put your main code here, to run repeatedly:\n\n}\n", { encoding: 'utf8' })];
                    case 8:
                        _a.sent();
                        return [2 /*return*/, this.loadSketch(node_1.FileUri.create(sketchDir).toString())];
                }
            });
        });
    };
    SketchesServiceImpl.prototype.getSketchFolder = function (uri) {
        return __awaiter(this, void 0, void 0, function () {
            var currentUri, sketch;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!uri) {
                            return [2 /*return*/, undefined];
                        }
                        currentUri = new uri_1.default(uri);
                        _a.label = 1;
                    case 1:
                        if (!(currentUri && !currentUri.path.isRoot)) return [3 /*break*/, 3];
                        return [4 /*yield*/, this._isSketchFolder(currentUri.toString())];
                    case 2:
                        sketch = _a.sent();
                        if (sketch) {
                            return [2 /*return*/, sketch];
                        }
                        currentUri = currentUri.parent;
                        return [3 /*break*/, 1];
                    case 3: return [2 /*return*/, undefined];
                }
            });
        });
    };
    SketchesServiceImpl.prototype.isSketchFolder = function (uri) {
        return __awaiter(this, void 0, void 0, function () {
            var sketch;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._isSketchFolder(uri)];
                    case 1:
                        sketch = _a.sent();
                        return [2 /*return*/, !!sketch];
                }
            });
        });
    };
    SketchesServiceImpl.prototype._isSketchFolder = function (uri) {
        return __awaiter(this, void 0, void 0, function () {
            var fsPath, stat, _a, basename, files, i, sketch, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        fsPath = node_1.FileUri.fsPath(uri);
                        _c.label = 1;
                    case 1:
                        _c.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, util_1.promisify(fs.lstat)(fsPath)];
                    case 2:
                        stat = _c.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        _a = _c.sent();
                        return [3 /*break*/, 4];
                    case 4:
                        if (!(stat && stat.isDirectory())) return [3 /*break*/, 11];
                        basename = path.basename(fsPath);
                        return [4 /*yield*/, util_1.promisify(fs.readdir)(fsPath)];
                    case 5:
                        files = _c.sent();
                        i = 0;
                        _c.label = 6;
                    case 6:
                        if (!(i < files.length)) return [3 /*break*/, 11];
                        if (!(files[i] === basename + '.ino' || files[i] === basename + '.pde')) return [3 /*break*/, 10];
                        _c.label = 7;
                    case 7:
                        _c.trys.push([7, 9, , 10]);
                        return [4 /*yield*/, this.loadSketch(node_1.FileUri.create(fsPath).toString())];
                    case 8:
                        sketch = _c.sent();
                        return [2 /*return*/, sketch];
                    case 9:
                        _b = _c.sent();
                        return [3 /*break*/, 10];
                    case 10:
                        i++;
                        return [3 /*break*/, 6];
                    case 11: return [2 /*return*/, undefined];
                }
            });
        });
    };
    SketchesServiceImpl.prototype.isTemp = function (sketch) {
        return __awaiter(this, void 0, void 0, function () {
            var sketchPath, temp;
            return __generator(this, function (_a) {
                sketchPath = node_1.FileUri.fsPath(sketch.uri);
                temp = os.tmpdir();
                // Note: VS Code URI normalizes the drive letter. `C:` will be converted into `c:`.
                // https://github.com/Microsoft/vscode/issues/68325#issuecomment-462239992
                if (os_1.isWindows) {
                    if (WIN32_DRIVE_REGEXP.exec(sketchPath)) {
                        sketchPath = utils_1.firstToLowerCase(sketchPath);
                    }
                    if (WIN32_DRIVE_REGEXP.exec(temp)) {
                        temp = utils_1.firstToLowerCase(temp);
                    }
                }
                return [2 /*return*/, sketchPath.indexOf(prefix) !== -1 && sketchPath.startsWith(temp)];
            });
        });
    };
    SketchesServiceImpl.prototype.copy = function (sketch, _a) {
        var destinationUri = _a.destinationUri;
        return __awaiter(this, void 0, void 0, function () {
            var source, exists, destination;
            var _this = this;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        source = node_1.FileUri.fsPath(sketch.uri);
                        return [4 /*yield*/, util_1.promisify(fs.exists)(source)];
                    case 1:
                        exists = _b.sent();
                        if (!exists) {
                            throw new Error("Sketch does not exist: " + sketch);
                        }
                        if (!(sketch.uri === destinationUri)) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.loadSketch(sketch.uri)];
                    case 2:
                        _b.sent(); // Sanity check.
                        return [2 /*return*/, sketch.uri];
                    case 3:
                        destination = node_1.FileUri.fsPath(destinationUri);
                        return [4 /*yield*/, new Promise(function (resolve, reject) {
                                ncp_1.ncp.ncp(source, destination, function (error) { return __awaiter(_this, void 0, void 0, function () {
                                    var newName, oldPath, newPath, e_4;
                                    return __generator(this, function (_a) {
                                        switch (_a.label) {
                                            case 0:
                                                if (error) {
                                                    reject(error);
                                                    return [2 /*return*/];
                                                }
                                                newName = path.basename(destination);
                                                _a.label = 1;
                                            case 1:
                                                _a.trys.push([1, 5, , 6]);
                                                oldPath = path.join(destination, new uri_1.default(sketch.mainFileUri).path.base);
                                                newPath = path.join(destination, newName + ".ino");
                                                if (!(oldPath !== newPath)) return [3 /*break*/, 3];
                                                return [4 /*yield*/, util_1.promisify(fs.rename)(oldPath, newPath)];
                                            case 2:
                                                _a.sent();
                                                _a.label = 3;
                                            case 3: return [4 /*yield*/, this.loadSketch(destinationUri)];
                                            case 4:
                                                _a.sent(); // Sanity check.
                                                resolve();
                                                return [3 /*break*/, 6];
                                            case 5:
                                                e_4 = _a.sent();
                                                reject(e_4);
                                                return [3 /*break*/, 6];
                                            case 6: return [2 /*return*/];
                                        }
                                    });
                                }); });
                            })];
                    case 4:
                        _b.sent();
                        return [2 /*return*/, node_1.FileUri.create(destination).toString()];
                }
            });
        });
    };
    SketchesServiceImpl.prototype.archive = function (sketch, destinationUri) {
        return __awaiter(this, void 0, void 0, function () {
            var client, archivePath, req;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.loadSketch(sketch.uri)];
                    case 1:
                        _a.sent(); // sanity check
                        return [4 /*yield*/, this.coreClient()];
                    case 2:
                        client = (_a.sent()).client;
                        archivePath = node_1.FileUri.fsPath(destinationUri);
                        return [4 /*yield*/, util_1.promisify(fs.exists)(archivePath)];
                    case 3:
                        if (!_a.sent()) return [3 /*break*/, 5];
                        return [4 /*yield*/, util_1.promisify(fs.unlink)(archivePath)];
                    case 4:
                        _a.sent();
                        _a.label = 5;
                    case 5:
                        req = new commands_pb_1.ArchiveSketchReq();
                        req.setSketchPath(node_1.FileUri.fsPath(sketch.uri));
                        req.setArchivePath(archivePath);
                        return [4 /*yield*/, new Promise(function (resolve, reject) {
                                client.archiveSketch(req, function (err) {
                                    if (err) {
                                        reject(err);
                                        return;
                                    }
                                    resolve(destinationUri);
                                });
                            })];
                    case 6:
                        _a.sent();
                        return [2 /*return*/, destinationUri];
                }
            });
        });
    };
    SketchesServiceImpl.prototype.coreClient = function () {
        return __awaiter(this, void 0, void 0, function () {
            var coreClient;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, new Promise(function (resolve) { return __awaiter(_this, void 0, void 0, function () {
                            var client, toDispose;
                            var _this = this;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4 /*yield*/, this.coreClientProvider.client()];
                                    case 1:
                                        client = _a.sent();
                                        if (client) {
                                            resolve(client);
                                            return [2 /*return*/];
                                        }
                                        toDispose = this.coreClientProvider.onClientReady(function () { return __awaiter(_this, void 0, void 0, function () {
                                            var client;
                                            return __generator(this, function (_a) {
                                                switch (_a.label) {
                                                    case 0: return [4 /*yield*/, this.coreClientProvider.client()];
                                                    case 1:
                                                        client = _a.sent();
                                                        if (client) {
                                                            toDispose.dispose();
                                                            resolve(client);
                                                            return [2 /*return*/];
                                                        }
                                                        return [2 /*return*/];
                                                }
                                            });
                                        }); });
                                        return [2 /*return*/];
                                }
                            });
                        }); })];
                    case 1:
                        coreClient = _a.sent();
                        return [2 /*return*/, coreClient];
                }
            });
        });
    };
    __decorate([
        inversify_1.inject(config_service_1.ConfigService),
        __metadata("design:type", Object)
    ], SketchesServiceImpl.prototype, "configService", void 0);
    __decorate([
        inversify_1.inject(core_client_provider_1.CoreClientProvider),
        __metadata("design:type", core_client_provider_1.CoreClientProvider)
    ], SketchesServiceImpl.prototype, "coreClientProvider", void 0);
    __decorate([
        inversify_1.inject(notification_service_server_1.NotificationServiceServerImpl),
        __metadata("design:type", notification_service_server_1.NotificationServiceServerImpl)
    ], SketchesServiceImpl.prototype, "notificationService", void 0);
    __decorate([
        inversify_1.inject(env_variables_1.EnvVariablesServer),
        __metadata("design:type", Object)
    ], SketchesServiceImpl.prototype, "envVariableServer", void 0);
    SketchesServiceImpl = __decorate([
        inversify_1.injectable()
    ], SketchesServiceImpl);
    return SketchesServiceImpl;
}());
exports.SketchesServiceImpl = SketchesServiceImpl;
//# sourceMappingURL=sketches-service-impl.js.map